Summary: An FTP daemon provided by Washington University.
Name: wu-ftpd
Version: 2.6.1
Release: 22
License: BSD
Group: System Environment/Daemons
URL: http://www.wu-ftpd.org/
#Source: ftp://ftp.wu-ftpd.org/pub/wu-ftpd/wu-ftpd-%{version}.tar.gz
Source: wu-ftpd-2.7.0-20010531.tar.bz2
Source1: ftpd.log
Source2: ftp.pamd
Source3: wu-ftpd-xinetd
Source4: ftpaccess
Patch0: wu-ftpd-2.6.0-redhat.patch
Patch1: wu-ftpd-2.6.1-sec.patch
Patch5: wu-ftpd-2.6.0-owners.patch
Patch6: wu-ftpd-2.6.2-realpatch.patch
Patch8: wu-ftpd-2.6.1-escape.patch
Patch9: wu-ftpd-2.6.2-time_fix.patch
Patch10: wu-ftpd-2.6.1-connect_dos.patch
Patch11: wu-ftpd-2.6.2-skeychallenge.patch
Provides: ftpserver
Prereq: fileutils
Requires: xinetd, /etc/pam.d/system-auth
Buildroot: %{_tmppath}/%{name}-root

%description
The wu-ftpd package contains the wu-ftpd FTP (File Transfer Protocol)
server daemon. The FTP protocol is a method of transferring files
between machines on a network and/or over the Internet. Wu-ftpd's
features include logging of transfers, logging of commands, on the fly
compression and archiving, classification of users' type and location,
per class limits, per directory upload permissions, restricted guest
accounts, system wide and per directory messages, directory alias,
cdpath, filename filter, and virtual host support.

%prep
%setup -q -n %{name}
mkdir rhsconfig
%patch0 -p1 -b .redhat
%patch1 -p1 -b .sec
%patch5 -p1 -b .owners
%patch6 -p1 -b .realpath
%patch8 -p1 -b .escape
%patch9 -p1 -b .time_fix
%patch10 -p1 -b .connect_dos
%patch11 -p1 -b .skeychallenge

find . -type d -name CVS |xargs rm -rf

%configure --enable-quota --enable-pam --disable-rfc931 --enable-ratios \
	--enable-passwd --disable-dnsretry --enable-ls

perl -pi -e "s,/\* #undef SHADOW_PASSWORD \*/,#define SHADOW_PASSWORD 1,g" src/config.h

# Make the version what we want it to be
cat >src/newvers.sh <<EOF
echo 'char version[] = "Version wu-%{version}-%{release}";' >vers.c
EOF
chmod 0755 src/newvers.sh

%build
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc $RPM_BUILD_ROOT%{_sbindir}
make install DESTDIR=$RPM_BUILD_ROOT
install -c -m755 util/xferstats $RPM_BUILD_ROOT%{_sbindir}
cd rhsconfig
install -c -m 600 ftpusers  ftphosts ftpgroups ftpconversions $RPM_BUILD_ROOT/etc
strip -R .comments $RPM_BUILD_ROOT%{_sbindir}/* || :
mkdir -p $RPM_BUILD_ROOT/etc/{pam,logrotate}.d
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc/logrotate.d/ftpd
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/pam.d/ftp
ln -sf in.ftpd $RPM_BUILD_ROOT/usr/sbin/wu.ftpd
ln -sf in.ftpd $RPM_BUILD_ROOT/usr/sbin/in.wuftpd

mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
install -m644 %SOURCE3 $RPM_BUILD_ROOT/etc/xinetd.d/wu-ftpd

install -c -m0600 %{SOURCE4} $RPM_BUILD_ROOT/etc

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ ! -f /var/log/xferlog ]; then
    touch /var/log/xferlog
    chmod 600 /var/log/xferlog
fi

%files
%defattr(-,root,root)
%config(noreplace) /etc/xinetd.d/wu-ftpd
%doc README ERRATA CHANGES CONTRIBUTORS
%doc doc/HOWTO doc/TODO doc/examples
%{_mandir}/*/*.*
%config /etc/ftp*
%config /etc/pam.d/ftp
%config /etc/logrotate.d/ftpd

%defattr(0755,bin,bin)
%{_sbindir}/*
%{_bindir}/*

%changelog
* Mon Mar  1 2004 Thomas Woerner <twoerner@redhat.com> 2.6.1-22
- bugfix release CAN-2004-0148 escape from home
- bugfix release: connect_dos, skeychallenge
- bugfix for xferlog: using TZ environment variable (#115979)

* Fri Jul 25 2003 Thomas Woerner <twoerner@redhat.com> 2.6.1-21
- bugfix release CAN-2003-0466 off-by-one

* Wed Nov 21 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.6.1-20
- Improve the fix

* Tue Nov 20 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.6.1-19
- Fix security bug in ftpglob

* Tue Jun 26 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.6.1-18
- Remove a couple of CVS admin files from the docs (#44921)

* Thu May 31 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.6.1-17
- Update to current CVS stable branch

* Wed Mar 28 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add fix for 2 possible DoS attacks from CVS.
- Fix #31158

* Tue Mar  6 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Hack in support for large files (#30693)

* Fri Mar  2 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add fixes from current 2.6.2 branch, fixes insecure tempfile
  creation in privatepw

* Tue Feb 27 2001 Preston Brown <pbrown@redhat.com>
- noreplace xinetd.d file

* Sat Jan 20 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Adapt /etc/ftpconversions to current anonftp (3.1-1)
- Remove the unused rhsconfig/ftpaccess file

* Fri Jan 12 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Set /etc/ftpaccess to more sane default settings,
  add comments on modifying the file
  Bugs #23744, #23745

* Wed Jan 10 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add URL tag (#22986)

* Fri Dec 01 2000 Trond Eivind Glomsrd <teg@redhat.com>
- make sure it's turned off by default

* Wed Oct 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Change the ftpaccess file to more secure defaults

* Thu Oct  5 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- enable internal ls (experimental features are ok for rawhide...)
  The feature needs testing and seems relatively stable now.
- disable DNS retries (Bug #8149)

* Wed Aug  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- --disable-ls, we shouldn't keep experimental features in a release.

* Sun Jul 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix strange listing data bug (#13752)
- run make during the %%build phase

* Tue Jul 18 2000 Bill Nottingham <notting@redhat.com>
- add description & default to xinetd file

* Fri Jul 14 2000 Jeff Johnson <jbj@redhat.com>
- correct man page references (#12930).

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sat Jul  1 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.6.1
- get rid of most of our patches; they're in 2.6.1.

* Fri Jun 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix the security bugfix

* Fri Jun 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix security bug w/ SITE EXEC

* Thu Jun  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- Modify PAM configuration to use system-auth
- Miscellaneous FHS fixes

* Mon May 22 2000 Trond Eivind Glomsrd <teg@redhat.com>
- Add /etc/xinetd.d/wu-ftpd

* Sat May 20 2000 Bill Nottingham <notting@redhat.com>
- use normal getpwnam/getpwuid for standard password files (for NIS, etc.)

* Sun Mar 26 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- make binaries readable

* Mon Mar 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- recompile

* Fri Mar 10 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix bug in configure script

* Sun Mar  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- remove the conflict between PAM and alternative passwd files and enable PAM

* Sun Mar  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- fix up behavior for missing entries in shadow password files when the
  non-shadow password file contains all info.
  This fixes the MD5 problem.
- remove the nlstbug patch; it's now included in the bero patch.

* Mon Feb 28 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- fix up NLST behavior on broken symlinks

* Sat Feb 12 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Merge some features from BeroFTPD people requested:
  - alternate passwd/shadow files for virtual hosts
  - ratios
- switch to using autoconfed build - it's much better on linux.
  build makes some faulty assumptions based on its glibc 2.0 and
  kernel 2.0.x knowledge.

* Fri Feb  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- fix a bug (the port-allow ftpaccess option was broken)
- handle compressed man pages

* Thu Oct 21 1999 Cristian Gafton <gafton@redhat.com>
- version 2.6.0, but no autoconf yet

* Tue Sep 21 1999 Cristian Gafton <gafton@redhat.com>
- patch for allowing logins by users that do not have a local account on the
  machine, but are autheticated by PAM from a different database.

* Mon Sep 06 1999 Cristian Gafton <gafton@redhat.com>
- fix ident patch

* Tue Aug 31 1999 Michael K. Johnson <johnsonm@redhat.com>
- fixed roff subtlety

* Wed Aug 25 1999 <jbj@redhat.com>
- fix ftpd.c mapped_path buffer overflow.

* Mon Aug 23 1999 <jbj@redhat.com>
- apply fix for login bug (#1599).

* Sat Aug 21 1999 <jbj@redhat.com>
- include all quick-fixes from ftp.vr.net (#3482,#3866).

* Sat Jun 12 1999 <alan@redhat.com>
- Added the new -I option to toggle the use of ident

* Mon Jun  7 1999 <jbj@redhat.com>
- update to 2.5.0 (pathname patch no longer needed).
- use "/bin/ps -f -p #" to get correct ftpwho info (#2455).
- revert glob patch in order to fix "cd ~user" (#2798) and "ls foo*" (#2944).

* Mon Apr 19 1999 <ewt@redhat.com>
- fixed pathname overflow patch

* Sat Apr 17 1999 <ewt@redhat.com>
- use libc glob function
- patched up some overflows - ick.

* Fri Apr 16 1999 Cristian Gafton <gafton@redhat.com>
- version 2.4.2-vr17. Thank GOD! - important patches are already in. Joy an
  happyness will reign the world now.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 6)

* Mon Feb 15 1999 Cristian Gafton <gafton@redhat.com>
- update to 2.4.2-beta18-vr14 from ftp.vr.net

* Mon Aug  3 1998 Jeff Johnson <jbj@redhat.com>
- fix busted symlinks.

* Thu Jul 16 1998 Jeff Johnson <jbj@redhat.com>
- update to 2.4.2-beta18

* Tue Jun 09 1998 Prospector System <bugs@redhat.com>
- translations modified for de

* Tue Jun  9 1998 Jeff Johnson <jbj@redhat.com>
- updated to 2.4.2-beta17 (fix problems #679/#680)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sun May 03 1998 Cristian Gafton <gafton@redhat.com>
- fixed the ps patch for the new ps convention (use ps www instead of ps -www)

* Sun Apr 12 1998 Cristian Gafton <gafton@redhat.com>
- added %clean section

* Sat Apr 11 1998 Cristian Gafton <gafton@redhat.com>
- updated to 2.4.2b16
- BuildRoot

* Fri Dec 12 1997 Cristian Gafton <gafton@redhat.com>
- added a patch to prevent a possible PORT command exploit
- cleaned up the .linux patch to get a clean compile on glibc

* Tue Oct 21 1997 Erik Troan <ewt@redhat.com>
- fixed copyright field

* Mon Oct 13 1997 Michael K. Johnson <johnsonm@redhat.com>
- Updated to new pam conventions.

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>
- Updated to beta 15, which fixes a number of security holes. Release 1
  if for RH 4.2, release 2 is glibc based.

* Mon Mar 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved from pam.conf to pam.d

* Mon Mar 03 1997 Erik Troan <ewt@redhat.com>
- xferstats should look for perl in /usr/bin, not /usr/local/bin
- provides the "ftpserver" virtual package

* Thu Feb 13 1997 Michael K. Johnson <johnsonm@redhat.com>
- Updated to beta-12, and created a new PAM patch from scratch, since
  the old one made massive changes to ftpd and caused some problems.
